*SAS Program 3.1-1;
OPTIONS NOCENTER PS=500 ls=150;
LIBNAME Lib 'd:\MLM\data';
Data data1;
  Set Lib.ML_IDUdata;
Proc sort; by site;

*Create grand mean centered level-1 variables;
Proc SQL;
  Create table lib.data_level_1 as select *, log(inject) as lninj, age-mean(age) as gdmc_age 
  from data1;
Quit;

*Create level-2 variables: HIV prevalence regio;
Proc SQL;
  Create table data2 as select site, hiv,
  100*(mean(hiv)) as m_hiv from data1
  Group by site; 
  Create table lib.data_level_2 as select distinct site, 
   m_hiv>15 as HIV_Region from data2;
Quit;

Data lib.ML_data_Chap3;
Merge lib.data_level_1(in=d1) lib.data_level_2(in=d2);
by site;
if d1=d2;
label HIV_Region='1-Higher HIV prevalence region; 0-Lowever HIV prevalence region';
label gdmc_age='Grand-mean centered age';

Proc means;
Class HIV_Region site;
Var hiv inject gender ethnic age highsch; 
Run;

Proc means;
Class HIV_Region;
Var hiv inject gender ethnic age highsch; 
Run;
