*SAS Program 5.3.5-4;
OPTIONS NOCENTER PS=500 ls=150;
LIBNAME lib 'd:\MLM\data';

Data ML_logit; 
 Set lib.ML_data_Chap5;

Reg_Eth=HIV_Region*ethnic;
PROC NLMIXED;
PARMS B0=-1.6 B1=-.15 B2=0.17 B3=0 B4=0 B5=0.8 B6=0 V_u0=0.5 V_u1=0.1 Cov_u01=0; 
Z=B0+B1*ethnic+B2*gender+B3*gdmc_age+B4*highsch+B5*HIV_Region
   +B6*Reg_Eth+(u0j+u1j*ethnic); 
If (heavy_inj=1) then P=1/(1+exp(-Z));
Else P=1-(1/(1+exp(-Z)));
LL=LOG(P);
MODEL heavy_inj ~ GENERAL(LL);
RANDOM u0j u1j~normal([0,0],[V_u0,Cov_u01,V_u1]) SUBJECT=site;
Run;

