*SAS Program 5.3.5-5;
OPTIONS NOCENTER PS=500 ls=150;
LIBNAME lib 'd:\HLM_book\data';

Data ML_logit; 
 Set lib.ML_data_Chap5;
Reg_Eth=HIV_Region*ethnic;
PROC NLMIXED;
PARMS B0=-1.6 B1=-.15 B2=0.17 B3=0 B4=0 B5=0.8 B6=0 t11=0.7 t22=0.3 t12=0; 
Z=B0+B1*ethnic+B2*gender+B3*gdmc_age+B4*highsch+B5*HIV_Region
   +B6*Reg_Eth+(u0j+u1j*ethnic); 
If (heavy_inj=1) then P=1/(1+exp(-Z));
Else P=1-(1/(1+exp(-Z)));
LL=LOG(P);
V_u0=t11*t11;
Cov_u01=t11*t12;
V_u1=t12*t12+t22*t22;
MODEL heavy_inj ~ GENERAL(LL);
RANDOM u0j u1j~normal([0,0],[V_u0,Cov_u01,V_u1]) SUBJECT=site;
estimate 'Var(u0)' V_u0;
estimate 'Cov(u0, u1)' Cov_u01;
estimate 'Var(u1)' V_u1;
Run;
