*SAS Program 5.6.4-7;
OPTIONS NOCENTER PS=500 ls=150;
LIBNAME Lib 'd:\MLM\data';

Data data1;
  Set Lib.ML_data_Chap5;

PROC SQL;
Create table temp as select site, heavy_inj, 
 100*(mean(heavy_inj)) as m_heavy_inj from data1
Group by site;
Create table data2 as select distinct site, m_heavy_inj, 
 m_heavy_inj>15 as Hinj_Region from temp;
Quit;

Data data3;
Merge data1 data2; by site;
Hinj_gender=Hinj_Region*gender;

PROC NLMIXED tech=nrridg;
PARMS B0=0.07 B_Hinj_Region=0.46 B_gender=1.05 B_Hinj_gender=-0.21
      B_ethnic=0.20 B_gdmc_age=0.05 B_highsch=0 STD=0.4 k=2;
eta=B0+B_Hinj_Region*Hinj_Region+B_gender*gender+B_Hinj_gender*Hinj_gender
    +B_ethnic*ethnic+B_gdmc_age*gdmc_age+B_highsch*highsch+u0; 
lambda=exp(eta);
* pdf;
pdf=gamma(jailyear+1/k)/(gamma(jailyear+1)*(gamma(1/k)))*(((k*lambda)**jailyear)/(1+k*lambda)**(jailyear+1/k));
*loglikelihood;
if pdf > 1e-8 then LL = log(pdf); else LL = -1e20; 
Model jailyear ~ GENERAL(LL);
RANDOM u0 ~ NORMAL(0, STD*STD) SUBJECT=SITE;
Estimate 'intercept variance s2v' std*std;
Run;
